@echo off
rem
rem	Script zum Aufrumen und Bereinigen von Laufwerk C
rem	(gesteuert ber %HOMEDRIVE%)
rem	mit verschiedenen Optionen zum Beenden ...
rem	Version ij
rem	First: 01/2005
rem	Last: 27.01.2013
rem	01.04.2014: Windows 8 | Quick Restart
rem	29.05.2014 Div. Korrekturen
rem	20.06.2014 04.03.03: QuickRestart WinXP
rem	21.06.2014 04.03.04: LogOff XP korrigert (Option /I zugefgt)
set BatchVer=04.03.04
rem
rem
rem

set DRIVE=C
set ENDPROGPATH=%HOMEDRIVE%\batch
set Benutzer==%USER%
if %Benutzer%~==~ set Benutzer=%USERNAME%
goto ChkWinVer

:run
if	%1~==set~ goto FirstTime
if not exist %ENDPROGPATH%\beenden.init goto Firsttime
if not exist %ENDPROGPATH%\beenden.rep goto SetInforep
if /I	%1~==QuickRestart~	goto beenden


:Start
echo %date% %time% Run %1 fr %Benutzer% (Ver:%BatchVer%) Prefetche lschen ...
echo %date% %time% %Benutzer% Run %1 %2 %BatchVer% Windows %WinVer% >> %ENDPROGPATH%\beenden.rep
echo %date% %time% %Benutzer% Prefetch and temp >> %ENDPROGPATH%\beenden.rep
del /F/S/Q "%WinDir%\Prefetch"
del /F/S/Q "%WinDir%\temp"
del /F/S/Q "%TMP%\*.*"
del /F/S/Q "%ALLUSERSPROFILE%\TEMP\*.*"

:bereinige
echo %date% %time% Datentrger %DRIVE% bereinigen ...
echo %date% %time% %Benutzer% Datentrger %DRIVE% bereinigen >> %ENDPROGPATH%\beenden.rep
call Cleanmgr.exe /d %DRIVE% /sagerun:11

:restart
echo %date% %time% Datentrger %DRIVE% defragmentieren
echo %date% %time% %Benutzer% Defragmentieren %Drive% >> %ENDPROGPATH%\beenden.rep
if %WinVerMain%==5 (
	rem XP und 2003
	call defrag %DRIVE%: /v 
) ELSE (
	if %WinVer%==6.0 (
		rem Windows Vista 
		call defrag -c -w -f 
	) ELSE (
		rem Windows 7 ff
		call defrag /C /H /U /V
	)
)
if /I	~%1==~loop goto restart
goto beenden

:FirstTime
echo Bitte haken Sie im nachfolgenden Auswahlfenster der
echo Datentrgerbereinigung alle Positionen an ...
echo %date% %time% %Benutzer% Firsttime >> %ENDPROGPATH%\beenden.init
Cleanmgr.exe /d %DRIVE% /sageset:11
goto start

:SetInforep
echo %date% %time% %Benutzer% Firsttime used >> %ENDPROGPATH%\beenden.rep
echo Diese Datei enthlt die Protokollierung zu %0 >> %ENDPROGPATH%\beenden.rep
echo (c) ij Jeschak %BatchVer% >> %ENDPROGPATH%\beenden.rep
goto start

:beenden
if /I	~%1==~beenden (
	shutdown /s /t 30 /d u:4:1 /c "Batch-Shutdown" /f
	echo %date% %time% %Benutzer% Shutdown >> c:\batch\beenden.rep
	echo Das System wird in 30 Sekunden ausgeschaltet ...
) ELSE (
  if /I	~%1==~Neustart (
	shutdown /r /t 30 /d u:4:1 /c "Batch-Restart" /f
	echo %date% %time% %Benutzer% Restart >> c:\batch\beenden.rep
	echo Das System wird in 30 Sekunden neu gestartet ...
  ) ELSE (
    if /I ~%1==~logoff   (
	echo *** LOGOFF***
	shutdown /l /t 30 /c "LogOff" /f
	echo %date% %time% %Benutzer% LogOff >> c:\batch\beenden.rep
	echo %BENUTZER% wird in 30 Sekunden abgemeldet ...
    ) ELSE (
      if /I ~%1==~ruhe     (
	shutdown /h /t 30 /c "Ruhestatus" /f
	echo %date% %time% %Benutzer% Ruhe >> c:\batch\beenden.rep
	echo Das System wird in 30 Sekunden in den Ruhezustand versetzt ...
      ) ELSE (
	if /I ~%1==~QuickRestart (
		echo %date% %time% %Benutzer% QuickRestart >> c:\batch\beenden.rep
		echo Das System wird in einer Sekunde neu gestartet ...
		if %WinVerMain%==5 (
			rem XP / 2003
			shutdown /r /t 1 /d u:4:1 /c "Batch-QuickRestart" /f
		) ELSE (
			shutdown /r /t 1 /d c:4:1 /c "Batch-QuickRestart" /f
		)
	)
      )
    )
  )
)
goto Ende

:ChkWinVer
for /f "tokens=3,4,5" %%i in ('ver') do (
	set "Ver1=%%i"
	set "Ver2=%%j"
	set "Ver3=%%k"
)
rem Ausgabe von ver [Version x.y.zzz]
rem bei XP	Microsoft Windows XP [Version 5.1.zzzz]
rem bei W2k3	Microsoft Windows XP [Version 5.2.zzzz]
rem bei Vista	Microsoft Windows [Version 6.0.zzzz]
rem bei W2k8	Microsoft Windows [Version 6.0.zzzz]e
rem bei Win7	Microsoft Windows [Version 6.1.zzzz]	
rem bei Win8.1	Microsoft Windows [Version 6.3.zzzz]
if	%Ver1%==XP (
	set ChkVer=%Ver3%
) ELSE (
	set ChkVer=%Ver2%
)
for /F "delims=. tokens=1,2" %%i in ("%ChkVer%") do (
	set "Ver1=%%i"
	set "Ver2=%%j"
)
set WinVer=%Ver1%.%Ver2%
set WinVerMain=%Ver1%
set Ver1=
set Ver2=
set Ver3=
goto run

:Ende
echo ... fertig aufrumen Laufwerk %DRIVE% %DATE% %TIME% ...
if NOT ~%1==~ pause
